<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2017 Amasty (https://www.amasty.com)
 * @package Amasty_Deliverydate
 */


namespace Amasty\Deliverydate\Observer\Admin\Order;

use Amasty\Deliverydate\Model\ResourceModel\Deliverydate;
use Magento\Framework\Event\ObserverInterface;

class Save implements ObserverInterface
{

    /**
     * @var \Amasty\Deliverydate\Model\DeliverydateFactory
     */
    protected $deliverydateFactory;

    /**
     * @var \Amasty\Deliverydate\Model\TintervalFactory
     */
    protected $tintervalFactory;

    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    protected $request;

    /**
     * @var Deliverydate
     */
    protected $deliverydateResourceModel;

    /**
     * @var \Amasty\Deliverydate\Model\ResourceModel\Tinterval
     */
    protected $tintervalResourceModel;

    public function __construct(
        \Amasty\Deliverydate\Model\DeliverydateFactory $deliverydateFactory,
        \Amasty\Deliverydate\Model\TintervalFactory $tintervalFactory,
        \Magento\Framework\App\RequestInterface $request,
        Deliverydate $deliverydateResourceModel,
        \Amasty\Deliverydate\Model\ResourceModel\Tinterval $tintervalResourceModel
    ) {
        $this->deliverydateFactory = $deliverydateFactory;
        $this->tintervalFactory = $tintervalFactory;
        $this->request = $request;
        $this->deliverydateResourceModel = $deliverydateResourceModel;
        $this->tintervalResourceModel = $tintervalResourceModel;
    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $order = $observer->getOrder();

        $data = $this->request->getParam('amdeliverydate');
        if (is_array($data) && !empty($data)) {
            $deliveryDate = $this->deliverydateFactory->create();
            $deliveryDate->prepareForSave($data, $order);
        }
    }
}
