<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2017 Amasty (https://www.amasty.com)
 * @package Amasty_Deliverydate
 */

namespace Amasty\Deliverydate\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\DB\Ddl\Table;

class UpgradeSchema implements UpgradeSchemaInterface {

    /**
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();
        
        if (version_compare($context->getVersion(), '1.1.0', '<')) {
            $this->_addTypeDayColumn($setup);
        }
    }

    /**
     * @param SchemaSetupInterface $setup
     */
    protected function _addTypeDayColumn(SchemaSetupInterface $setup) {
        $table = $setup->getTable('amasty_amdeliverydate_holidays');
        $setup->getConnection()
              ->addColumn(
                    $table,
                    'type_day',
                    [
                        'type'      => \Magento\Framework\DB\Ddl\Table::TYPE_SMALLINT,
                        'nullable'  => false,
                        'default'   => '0',
                        'comment'   => 'Day type'
                    ]);
    }
}