<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_Reports
 */


namespace Amasty\Reports\Model\ResourceModel\Sales\Payment\Grid;

use Magento\Framework\Data\Collection\Db\FetchStrategyInterface as FetchStrategy;
use Magento\Framework\Data\Collection\EntityFactoryInterface as EntityFactory;
use Magento\Framework\Event\ManagerInterface as EventManager;
use Psr\Log\LoggerInterface as Logger;

class Collection extends \Magento\Framework\View\Element\UiComponent\DataProvider\SearchResult
{
    /**
     * @var \Magento\Payment\Helper\Data
     */
    private $paymentHelper;

    /**
     * Initialize dependencies.
     *
     * @param EntityFactory $entityFactory
     * @param Logger $logger
     * @param FetchStrategy $fetchStrategy
     * @param EventManager $eventManager
     * @param string $mainTable
     * @param string $resourceModel
     */
    public function __construct(
        EntityFactory $entityFactory,
        Logger $logger,
        FetchStrategy $fetchStrategy,
        EventManager $eventManager,
        \Amasty\Reports\Model\ResourceModel\Sales\Payment\Collection $filterApplier,
        \Magento\Payment\Helper\Data $paymentHelper,
        $mainTable = 'sales_order',
        $resourceModel = '\Amasty\Reports\Model\ResourceModel\Sales\Payment\Collection'
    ) {
        parent::__construct($entityFactory, $logger, $fetchStrategy, $eventManager, $mainTable, $resourceModel);

        $filterApplier->prepareCollection($this);
        $this->paymentHelper = $paymentHelper;
    }


    protected function _afterLoad()
    {
        parent::_afterLoad(); // TODO: Change the autogenerated stub

        $paymentMethods = $this->paymentHelper->getPaymentMethods();
        foreach ($this->_items as $item) {
            $item->setPeriod($paymentMethods[$item->getPeriod()]['title']);
        }
        return $this;
    }
}
